﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace StateSpaceSearchCore
{
    public partial class Form1 : Form
    {
        State currentState;
        Problem problemInstance;
        Visualizer visualizer;
        SearchEngine eng;
        int resultIndex;

        public Form1()
        {
            InitializeComponent();
            var problemInstancesFolder = Path.Combine("..", "..", "..", "ProblemInstances");
            var rand = new Random(1234);

            //ZDE VYBERTE PROBLEM:

            //Fifteen Puzzle:
            problemInstance = new FifteenPuzzleProblem();
            visualizer = new FifteenPuzzleVisualizer();
            problemInstance.ReadFromFile(Path.Combine(problemInstancesFolder, "FP1.txt"));
            //problemInstance.ReadFromFile(Path.Combine(problemInstancesFolder, "FP2.txt"));
            //problemInstance.ReadFromFile(Path.Combine(problemInstancesFolder, "FP3.txt"));


            ////TSP:
            //problemInstance = new TSPProblem();
            //visualizer = new TSPVisualizer();
            //problemInstance.ReadFromFile(Path.Combine(problemInstancesFolder, "TSP1.txt"));
            ////problemInstance.ReadFromFile(Path.Combine(problemInstancesFolder, "TSP2.txt"));
            ////problemInstance = TSPProblem.CreateRandom(10, rand);

            ////Rubik's cube:
            //problemInstance = new RubicsCubeProblem();
            //visualizer = new CubeVisualizer();
            //problemInstance = RubicsCubeProblem.CreateRandom(2, 10, rand);
            ////problemInstance = RubicsCubeProblem.CreateRandom(3, 10, rand);
            ////problemInstance = RubicsCubeProblem.CreateRandom(4, 15, rand);


            //zbytek neni potreba menit

            visualizer.Init(pictureBox1);
            currentState = problemInstance.InitialState;
            visualizer.Visualize(currentState);
        }

        private void button1_Click(object sender, EventArgs e)
        {
			//ZDE NASTAVTE SVUJ SearchEngine

			eng = new SearchEngine();




			eng.Search(currentState);
            
        }

        private void button2_Click(object sender, EventArgs e)
        {
            List<State> result = eng.Result;
            resultIndex = 0;
            timer1.Enabled = true;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (resultIndex >= eng.Result.Count)
            {
                timer1.Enabled = false;
                return;
            }
            visualizer.Visualize(eng.Result[resultIndex]);
            resultIndex++;
        }



    }
}
